//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
/*
1) TakeProfit1 -  -  ,   ,  ""   .
     -    TakeProfit.    0,     TakeProfit.
2) DistanceBetweenOrders -         Buy  Sell.
3) TakeProfitPlus -    .
4) Koef -       .  -   1,  .
          .      ,  
    !!  !!

    TakeProfit   :

   DistanceBetweenOrders + SpreadPoint
   -----------------------------------  + TakeProfitPlus
              Koef - 1

   ,   20 .,  2,  3    7 . :
   (20 + 3) / (2 - 1) + 7 = 30 

    StopLoss   :

   TakeProfit + DistanceBetweenOrders

   ,  - 30   20 : 20 + 30 = 50 


-        999,   ,   .
  ,  MetaTrader       !
*/
#property copyright "AlexSTAL"
#property link      ""

#include <stderror.mqh>
#include <stdlib.mqh>

extern double DeltaBands = 4; //Bollinger Bands
extern int DistanceBetweenOrders = 20;
extern double Koef = 2;
extern int TakeProfitPlus = 7;
extern int TakeProfit1 = 10;
extern int TotalKacheli = 6;
int StopLoss = 0;
int TakeProfit = 0;

extern double FixedLots = 0.1;
extern int OrderMagicNum = 123;
int Slippage = 0;

static int TekStatus = 0;
double RabPrice = 0;
int RabTrend = 0;
bool TakeProfit1Modif = false;
double SpreadPoint = 0;

static bool  = true;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   if (Period() != PERIOD_M1)
     {
      MessageBox("    !");
       = false;
     }
   SpreadPoint = MarketInfo(Symbol(), MODE_SPREAD) * Point;
   TakeProfit = (DistanceBetweenOrders + SpreadPoint) / (Koef - 1) + TakeProfitPlus;
   StopLoss = TakeProfit + DistanceBetweenOrders;
   //----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   if (  == false )
      return(0);
   int err = 0;
   
   int Total4 = OrdersTotal();
   int MyTotal4 = 0;
   for(int pos4 = 0; pos4 < Total4; pos4++)
     {
      OrderSelect(pos4, SELECT_BY_POS, MODE_TRADES);
      if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()))
         MyTotal4 +=1;
     }
   if (MyTotal4 != 0)
     {
      if ( (TekStatus == 2) && (TakeProfit1Modif == false) )
        {
         int Total1 = OrdersTotal();
         int MyTotal1 = 0;
         int 1 = 0;
         for(int pos1 = 0; pos1 < Total1; pos1++)
           {
            OrderSelect(pos1, SELECT_BY_POS, MODE_TRADES);
            if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()) )
              {
               MyTotal1 += 1;
               if ( OrderType() > OP_SELL )
                  1 += 1;
              }
           }
         if (MyTotal1 == 2)
           {
            if (1 == 0)
              {
               for(int pos11 = 0; pos11 < Total1; pos11++)
                 {
                  OrderSelect(pos11, SELECT_BY_POS, MODE_TRADES);
                  if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()) && (OrderLots() == FixedLots) )
                    {
                     if ( OrderType() == OP_SELL )
                       {
                        OrderModify(OrderTicket(), 0, RabPrice + StopLoss * Point, RabPrice - TakeProfit * Point, 0, CLR_NONE);
                        TakeProfit1Modif = true;
                       }
                     if ( OrderType() == OP_BUY )
                       {
                        OrderModify(OrderTicket(), 0, RabPrice - StopLoss * Point, RabPrice + TakeProfit * Point, 0, CLR_NONE);
                        TakeProfit1Modif = true;
                       }
                    }
                 }
              }
           }
        }
      if (TekStatus >= 2)
        {
         int Total2 = OrdersTotal();
         int MyTotal2 = 0;
         int MyTotal2KolVo = 0;
         int 2 = 0;
         for(int pos2 = 0; pos2 < Total2; pos2++)
           {
            OrderSelect(pos2, SELECT_BY_POS, MODE_TRADES);
            if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()) )
              {
               MyTotal2 += 1;
               if ( NormalizeDouble(OrderLots(), 2) != 999.00 )
                  MyTotal2KolVo += 1;
               if ( OrderType() > OP_SELL )
                  2 += 1;
              }
           }
         if ( (2 == 0) && (MyTotal2 != 0) )
           {
            if ( MyTotal2KolVo >= TotalKacheli )
               return(0);
            
            if ( MyTotal2KolVo == TekStatus )
              {
               double VremTekStatus = TekStatus;
               int TekOrderType = 0;
               double TekPrice = 0, TekSL = 0, TekTP = 0;
               if ( RabTrend == -1 )
                 {
                  if ( (VremTekStatus / 2) != MathCeil(VremTekStatus / 2))
                    {
                     TekOrderType = OP_BUYSTOP;
                     TekPrice = RabPrice - SpreadPoint + DistanceBetweenOrders * Point;
                     TekSL = RabPrice - SpreadPoint - TakeProfit * Point;
                     TekTP = RabPrice - SpreadPoint + StopLoss * Point;
                    }
                  else
                    {
                     TekOrderType = OP_SELLSTOP;
                     TekPrice = RabPrice;
                     TekSL = RabPrice + StopLoss * Point;
                     TekTP = RabPrice - TakeProfit * Point;
                    }
                 }
               if ( RabTrend == 1 )
                 {
                  if ( (VremTekStatus / 2) != MathCeil(VremTekStatus / 2))
                    {
                     TekOrderType = OP_SELLSTOP;
                     TekPrice = RabPrice + SpreadPoint - DistanceBetweenOrders * Point;
                     TekSL = RabPrice + SpreadPoint + TakeProfit * Point;
                     TekTP = RabPrice + SpreadPoint - StopLoss * Point;
                    }
                  else
                    {
                     TekOrderType = OP_BUYSTOP;
                     TekPrice = RabPrice;
                     TekSL = RabPrice - StopLoss * Point;
                     TekTP = RabPrice + TakeProfit * Point;
                    }
                 }
               double TekLots = 3 * FixedLots * MathPow(Koef, TekStatus) / 4;
               if (TekLots < 1000)
                 {
                  OrderSend(Symbol(), TekOrderType, TekLots, TekPrice, 0, TekSL, TekTP, NULL, OrderMagicNum, 0, Red);
                 }
               else
                 {
                  double KolvoCeil = MathFloor(TekLots / 999);
                  double KolvoDrob = TekLots - KolvoCeil * 999;
                  Print(" 999: " + TekLots + "; " + KolvoCeil + "; " + KolvoDrob);
                  for(int ff = 0; ff < KolvoCeil; ff++)
                     OrderSend(Symbol(), TekOrderType, 999, TekPrice, 0, TekSL, TekTP, NULL, OrderMagicNum, 0, Red);
                  if (KolvoDrob != 0)
                     OrderSend(Symbol(), TekOrderType, KolvoDrob, TekPrice, 0, TekSL, TekTP, NULL, OrderMagicNum, 0, Red);
                 }
               TekStatus += 1;
            }
           }
         else
           {
            if (MyTotal2 == 2)
              {
               for(int pos3 = 0; pos3 < MyTotal2; pos3++)
                 {
                  int TekVremOrdersTotal = OrdersTotal();
                  for(int pos33 = 0; pos33 < TekVremOrdersTotal; pos33++)
                    {
                     OrderSelect(pos33, SELECT_BY_POS, MODE_TRADES);
                     if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()) )
                       {
                        OrderDelete(OrderTicket(), CLR_NONE);
                        break;
                       }
                    }
                 }
               TekStatus = 0; RabPrice = 0; RabTrend = 0; TakeProfit1Modif = false;
              }
           }
        }
     }

   //-------------------------------------------------------------------------------------
   int Total0 = OrdersTotal();
   int MyTotal0 = 0;
   for(int pos0 = 0; pos0 < Total0; pos0++)
     {
      OrderSelect(pos0, SELECT_BY_POS, MODE_TRADES);
      if ( (OrderMagicNumber() == OrderMagicNum) && (OrderSymbol() == Symbol()))
         MyTotal0 +=1;
     }
   if (MyTotal0 == 0)
     {
      //   
      double TekBands = (iBands(NULL, PERIOD_M1, 100, 2, 0, PRICE_CLOSE, MODE_UPPER, 1) - iBands(NULL, PERIOD_M1, 100, 2, 0, PRICE_CLOSE, MODE_LOWER, 1)) / Point;
      if ( TekBands > DeltaBands)
         return(0);
      double TekADX = -(iADX(NULL, PERIOD_M1, 50, PRICE_CLOSE, MODE_PLUSDI, 1) - iADX(NULL, PERIOD_M1, 50, PRICE_CLOSE, MODE_MINUSDI, 1));
      double Sloss, Tprof, TekLimitPrice;
      int TekTicket;
      if ( TekADX < 0 )
        {
         // Sell
         RabPrice = Bid;
         RabTrend = -1;
         Sloss = RabPrice + StopLoss * Point;
         if (TakeProfit1 == 0)
           {
            Tprof = RabPrice - TakeProfit * Point;
            TakeProfit1Modif = true;
           }
         else
           {
            Tprof = RabPrice - TakeProfit1 * Point;
           }
         TekTicket = OrderSend(Symbol(), OP_SELL, FixedLots, Bid, Slippage, Sloss, Tprof, NULL, OrderMagicNum, 0, Red);
         err = GetLastError();
         if ( err == ERR_NOT_ENOUGH_MONEY)
           {
             = false;
            return(0);
           }
         // Buy STOP
         TekLimitPrice = RabPrice - SpreadPoint + DistanceBetweenOrders * Point;
         Sloss = TekLimitPrice - StopLoss * Point;
         Tprof = TekLimitPrice + TakeProfit * Point;
         TekTicket = OrderSend(Symbol(), OP_BUYSTOP, Koef * FixedLots, TekLimitPrice, 0, Sloss, Tprof, NULL, OrderMagicNum, 0, Red);
         TekStatus = 2;
        }
      if ( TekADX > 0 )
        {
         // Buy
         RabPrice = Ask;
         RabTrend = 1;
         Sloss = RabPrice - StopLoss * Point;
         if (TakeProfit1 == 0)
           {
            Tprof = RabPrice + TakeProfit * Point;
            TakeProfit1Modif = true;
           }
         else
           {
            Tprof = RabPrice + TakeProfit1 * Point;
           }
         TekTicket = OrderSend(Symbol(), OP_BUY, FixedLots, RabPrice, Slippage, Sloss, Tprof, NULL, OrderMagicNum, 0, Red);
         err = GetLastError();
         if ( err == ERR_NOT_ENOUGH_MONEY)
           {
             = false;
            return(0);
           }
         // Sell STOP
         TekLimitPrice = RabPrice + SpreadPoint - DistanceBetweenOrders * Point;
         Sloss = TekLimitPrice + StopLoss * Point;
         Tprof = TekLimitPrice - TakeProfit * Point;
         TekTicket = OrderSend(Symbol(), OP_SELLSTOP, Koef * FixedLots, TekLimitPrice, 0, Sloss, Tprof, NULL, OrderMagicNum, 0, Red);
         TekStatus = 2;
        }
     }
   //----
   return(0);
  }
//+------------------------------------------------------------------+